Welcome to the Dart API reference documentation, covering the official Dart API
libraries. Some of the most fundamental Dart libraries include:
   
  * [dart:core](dart-core/dart-core-library.html): Core functionality such as strings, numbers, collections, errors, dates, and URIs.
  * [dart:html](dart-html/dart-html-library.html): DOM manipulation for web apps.
  * [dart:io](dart-io/dart-io-library.html): I/O for command-line apps.
  
Except for `dart:core`, you must import a library before you can use it. Here's
an example of importing `dart:html` and `dart:math`:

```dart
import 'dart:html';
import 'dart:math';
```

You can install more libraries using the pub package manager. For information
on finding, using, and publishing libraries with pub, see 
[pub.dartlang.org](https://pub.dartlang.org).
  
The main site for learning and using Dart is
[www.dartlang.org](https://www.dartlang.org). Check out these additional pages:
  
  * [Tutorials](https://www.dartlang.org/docs/tutorials/)
  * [Programmer's Guide](https://www.dartlang.org/docs/)
  * [Samples](https://www.dartlang.org/samples/)
  * [A Tour of the Dart Libraries](https://www.dartlang.org/docs/dart-up-and-running/contents/ch03.html)
  
This API reference is automatically generated from the source code in the
[Dart project](https://github.com/dart-lang/sdk). If you'd like to contribute to
this documentation, see
[Contributing](https://github.com/dart-lang/sdk/wiki/Contributing).
